doHUDMessages()
{
	self waittill("welcome");
	
	if(!isdefined(self.pers["cj_hudmsg"]))
	{
		wait 1;
		self iprintlnbold(&"CJ_BLANK");
		self iprintlnbold(&"CJ_MELEE_SAVE");
		wait 2;
		self iprintlnbold(&"CJ_USE_LOAD");
		wait 2;
		
		if(getCvarInt("cj_restocknades"))
			self iprintlnbold(&"CJ_HOLD_FIRE");
		
		self.pers["cj_hudmsg"] = true;
	}
}

_MeleeKey()
{
	self endon("end_saveposition_threads");
	self endon("disconnect");

	for(;;)
	{
		if(self meleeButtonPressed())
			{
				catch_next = false;
	
				for(i=0; i<=0.10; i+=0.01)
				{
					if(catch_next && self meleeButtonPressed())
					{
						wait 0.1;
						if(self isOnground())
						{
							self thread savePos();
							wait 1;
							break;
						}
						else if (!(self isOnGround()) && self meleeButtonPressed())
						{
							self iprintln(&"CJ_ON_GROUND");
							wait 1;
						}
					}
					else if(!(self meleeButtonPressed()))
						catch_next = true;
	
					wait 0.01;
				}
			}
		


		wait 0.05;
	}

}

_UseKey()
{
	self endon("end_saveposition_threads");
	self endon("disconnect");

	for(;;)
	{
		if(self useButtonPressed())
		{
			catch_next = false;

			for(i=0; i<=0.10; i+=0.01)
			{
				if(catch_next && self useButtonPressed())
				{
					wait 0.1;
					self thread loadPos();
					wait 1;
					break;
				}
				else if(!(self useButtonPressed()))
					catch_next = true;

				wait 0.01;
			}
		}

		wait 0.05;
	}
}

loadPos()
{
	if(!isDefined(self.saved_origin))
	{
		self iprintlnbold(&"CJ_NO_POSITION");
		return;
	}
	else
	{
		if(self positions(60))
			{
			self iprintlnbold(&"CJ_POSITION_OCCUPIED");
			self iprintlnbold(&"CJ_PLEASE_WAIT");
			return;
			}
		else
			{
			self setPlayerAngles(self.saved_angles); // angles need to come first
			self setOrigin(self.saved_origin);
			self iprintln(&"CJ_LOADED");
			}
	}
}

savePos()
{
	self.saved_origin = self.origin;
	self.saved_angles = self.angles;
	self iprintln(&"CJ_SAVED");
}

positions(range)
{
	if(!range)
		return true;

	// Get all players and pick out the ones that are playing
	allplayers = getentarray("player", "classname");
	players = [];
	for(i = 0; i < allplayers.size; i++)
	{
		if(allplayers[i].sessionstate == "playing")
			players[players.size] = allplayers[i];
	}

	// Get the players that are in range
	sortedplayers = sortByDist(players, self);

	// Need at least 2 players (myself + one team mate)
	if(sortedplayers.size<2)
		return false;

	// First player will be myself so check against second player
	distance = distance(self.saved_origin, sortedplayers[1].origin);
	if( distance <= range )
		return true;
	else
		return false;
}

sortByDist(points, startpoint, maxdist, mindist)
{
	if(!isdefined(points))
		return undefined;
	if(!isdefineD(startpoint))
		return undefined;

	if(!isdefined(mindist))
		mindist = -1000000;
	if(!isdefined(maxdist))
		maxdist = 1000000; // almost 16 miles, should cover everything.

	sortedpoints = [];

	max = points.size-1;
	for(i = 0; i < max; i++)
	{
		nextdist = 1000000;
		next = undefined;

		for(j = 0; j < points.size; j++)
		{
			thisdist = distance(startpoint.origin, points[j].origin);
			if(thisdist <= nextdist && thisdist <= maxdist && thisdist >= mindist)
			{
				next = j;
				nextdist = thisdist;
			}
		}

		if(!isdefined(next))
			break; // didn't find one that fit the range, stop trying

		sortedpoints[i] = points[next];

		// shorten the list, fewer compares
		points[next] = points[points.size-1]; // replace the closest point with the end of the list
		points[points.size-1] = undefined; // cut off the end of the list
	}

	sortedpoints[sortedpoints.size] = points[0]; // the last point in the list

	return sortedpoints;
}