init()
{
	level._player["burn"] = loadfx ("fx/props/barrel_fire2.efx");
	thread _punish();
}

/* Global Punishment */
_punish()
{
	reason = undefined;
while(1)
{
	for(;;)
	{
		if(getCvar("punish") != " ")
			break;
		
		wait 0.5;
	}

	punishplayers = getCvar("punish");
	punishtokens = strTok(punishplayers, "|");

	punishment = punishtokens[0];
	if(punishtokens.size > 2)
	{
		_i = punishtokens.size - 1;
		for(i=1;i<100;i++)
		{
			tempstr = "" + i;
			if(punishtokens[_i] == tempstr)
			{
				reason = "No Reason";
				break;
			}
			else
				reason = punishtokens[_i];
		}
	}
	else
		reason = "No Reason";
	
	level.reason = reason;

	
	players = getentarray("player","classname");
	for(i=0;i<players.size;i++)
	{
		ent[i] = players[i] getEntityNumber();
		switch(punishment)
		{
			case "burn":
				players[i] thread _burn_list(ent[i]);
				break;
			case "freeze":
				players[i] thread _freeze_list(ent[i]);
				break;
			case "suicide":
				players[i] thread _suicide_list(ent[i]);
				break;
			case "kick":
				players[i] thread _kick(ent[i]);
				break;
			case "spin":
				players[i] thread _spin_list(ent[i]);
				break;
			default:
				thread _error();
				break;
		}
	}
	level waittill ("punished");
	setCvar("punish", " ");
	wait 3;
	level.reason = " ";
}
}

/* Burn Punishment */
_burn_list(num)
{	
	burnplayers = getCvar("punish");
	burntokens = strTok(burnplayers, "|");
	
	for(i=0;i<burntokens.size;i++)
	{
		if(i != 0)
		{
			if(level.reason != "No Reason")
			{
				if(i != burntokens.size - 1)
				{
					burn[i] = burntokens[i];
					burn[i] = int(burn[i]);
					
					if(num == burn[i])
						self _do_burn();
				}
			}
			else if(level.reason == "No Reason")
			{
					burn[i] = burntokens[i];
					burn[i] = int(burn[i]);
					
					if(num == burn[i])
						self _do_burn();
			}
		}			
		wait 0.1;
	}
	level notify ("punished");
}

_do_burn()
{
if(isPlayer(self) && isAlive(self) && self.sessionstate == "playing")
{
	self freezecontrols(true);
	
	self iprintln(&"CJ_FIRE");
	if(level.reason != "No Reason")
		self iprintln(&"CJ_REASON", level.reason);
		
	for(i=1;i<5;i++)
	{
		playfx(level._player["burn"], self.origin);
		_pain_sound = ("generaic_pain_german_" + (randomint(4) + 1));
		self playSound(_pain_sound);
		self.health = 1;
		wait 1;
	}
	_death_sound = ("generaic_death_german_" + (randomint(4) + 1));
	self playSound(_death_sound);
	self suicide();
}
}

/* Freeze Punishment */
_freeze_list(num)
{	
	freezeplayers = getCvar("punish");
	freezetokens = strTok(freezeplayers, "|");
		
	for(i=0;i<freezetokens.size;i++)
	{
		if(i != 0)
		{
			if(level.reason != "No Reason")
			{
				if(i != freezetokens.size - 1)
				{
					freeze[i] = freezetokens[i];
					freeze[i] = int(freeze[i]);
					
					if(num == freeze[i])
						self _do_freeze();
				}
			}
			else if(level.reason == "No Reason")
			{
					freeze[i] = freezetokens[i];
					freeze[i] = int(freeze[i]);
					
					if(num == freeze[i])
						self _do_freeze();
			}	
		}
	}
	level notify ("punished");
}

_do_freeze()
{
if(isPlayer(self) && isAlive(self) && self.sessionstate == "playing")
{
	self freezecontrols(true);
	
	self iprintln(&"CJ_FROZEN");
	if(level.reason != "No Reason")
		self iprintln(&"CJ_REASON", level.reason);
		
	wait 10;
	self iprintln(&"CJ_UNFROZEN");
	self freezecontrols(false);
}
}

/* Suicide Punishment */
_suicide_list(num)
{	
	suicideplayers = getCvar("punish");
	suicidetokens = strTok(suicideplayers, "|");
	
	for(i=0;i<suicidetokens.size;i++)
	{
		if(i != 0)
		{
			if(level.reason != "No Reason")
			{
				if(i != suicidetokens.size - 1)
				{
					suicide[i] = suicidetokens[i];
					suicide[i] = int(suicide[i]);
					
					if(num == suicide[i])
					{
						if(isPlayer(self) && isAlive(self) && self.sessionstate == "playing")
						{
							self iprintln(&"CJ_KILLED");
							self iprintln(&"CJ_REASON", level.reason);
							self suicide();
						}
					}
				}
			}
			else if(level.reason == "No Reason")
			{
				suicide[i] = suicidetokens[i];
				suicide[i] = int(suicide[i]);
					
				if(num == suicide[i])
				{					
					if(isPlayer(self) && isAlive(self) && self.sessionstate == "playing")
					{	
						self iprintln(&"CJ_KILLED");
						self suicide();
					}
				}							
			}	
		}
		wait 0.1;
	}
	level notify("punished");
}

/* Kick Punishment */
_kick(num)
{
	kickplayers = getCvar("punish");
	kicktokens = strTok(kickplayers, "|");
	
	for(i=0;i<kicktokens.size;i++)
	{
		if(i != 0)
		{
			if(level.reason != "No Reason")
			{
				if(i != kicktokens.size - 1)
				{
					kick[i] = kicktokens[i];
					kick[i] = int(kick[i]);
					
					if(num == kick[i])
					{				
						iprintln(&"CJ_NAME_KICK", self);
						self iprintlnbold(&"CJ_KICKED");
						self iprintlnbold(&"CJ_REASON", level.reason);
						wait 1.5;
						kick(self getEntityNumber());
					}
				}
			}
			else if(level.reason == "No Reason")
			{
				kick[i] = kicktokens[i];
				kick[i] = int(kick[i]);
					
				if(num == kick[i])
				{						
					iprintln(&"CJ_NAME_KICK", self);
					self iprintlnbold(&"CJ_KICKED");
					wait 1;
					kick(self getEntityNumber());
				}							
			}	
		}
		wait 0.1;
	}
	level notify("punished");
}

/* Spin Punishment */
_spin_list(num)
{	
	spinplayers = getCvar("punish");
	spintokens = strTok(spinplayers, "|");
	
	for(i=0;i<spintokens.size;i++)
	{
		if(i != 0)
		{
			if(level.reason != "No Reason")
			{
				if(i != spintokens.size - 1)
				{
					spin[i] = spintokens[i];
					spin[i] = int(spin[i]);
					
					if(num == spin[i])
						self _do_spin();
				}
			}
			else if(level.reason == "No Reason")
			{
					spin[i] = spintokens[i];
					spin[i] = int(spin[i]);
					
					if(num == spin[i])
						self _do_spin();
			}
		}			
		wait 0.1;
	}
	level notify ("punished");
}

_do_spin()
{
if(isPlayer(self) && isAlive(self) && self.sessionstate == "playing")
{
	self iprintln(&"CJ_SPIN");
	if(level.reason != "No Reason")
		self iprintln(&"CJ_REASON", level.reason);
		
	self.spin = undefined;
	for(i=0;i<180;i++)
	{
		self.spin = self getPlayerAngles();
		tempspin = self.spin + (0, 0, 6);
		self setPlayerAngles(tempspin);
		wait 0.01;
	}
	self setPlayerAngles((self.spin[0], self.spin[1], 0));
}
}

_error()
{
	wait 1;
	level notify("punished");
}